export interface BindFormxProps {
    key: string | number;
    prop: string;
    value: any;
    error: {
        message: string;
    };
    required: boolean;
    dispatch: (payload: dispatchFieldPayload) => void;
}
export interface FormState<T> {
    value: T;
    error: object;
}
export interface FormAction {
    type: 'setValue' | 'setError' | 'reset';
    payload: object;
}
export interface dispatchFieldPayload {
    type: 'change' | 'blur';
    prop: string;
    value: any;
    error?: {
        message: string;
    };
}
declare function useFormx<T extends object>(initialValue?: T, rules?: object): {
    bindFormx: (prop: string) => BindFormxProps;
    validate: (keys?: string | string[] | undefined) => Promise<any>;
    setFieldsValue: (payload: object) => void;
    setFieldsError: (payload: object) => void;
    resetFields: () => void;
    getField: (prop: string) => any[];
    value: T;
    error: object;
};
export default useFormx;
